/**************************************************************************
* Xtrophy ICQ - Originally written by tnc (xtrophy@it.dk)                 *
*'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''*
* io.cc                                                                   *
* Functions for input/output                                              *
**************************************************************************/

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include "io.h"

struct COLORS color;

char *aux_prompt;

int logFile = -1;
/*utflyttade grejer pga AST'n*/
int done = 0;
char input[BUFSIZE];
/*dax att s{nda ny qio*/
int io=0;

/*vms-stuff*/
struct ioblock
{
   short        status;
   short        offset;
   char         termchar;
   char         notused;
   char         termlen;
   char         curpos;
} iosb;
struct itmblock
{
   short        length;
   short        type;
   long         buffer;
   long         ret;
}   itm[3];
/* */
void icq_log(char *from_user, char *str) {
    char logTo[128];

    strcpy(logTo, user_cfg.logfile);
/*    if(strlen(from_user) > 0) {
      strcat(logTo, ".");
      strcat(logTo, from_user);
    }*/

    if(DEBUG) printf("[%s] %s\n", from_user, logTo);

    logFile = open(logTo, O_WRONLY|O_CREAT|O_APPEND, S_IRUSR|S_IWUSR|S_IRGRP);
    if(strlen(from_user)>0)
    {
    	write(logFile, from_user,strlen(from_user));
    	write(logFile, ": ",strlen(": "));
    }
    write(logFile, str, strlen(str));
    close(logFile);
} // icq_log

void close_log() {
    if (logFile != -1) {
	close(logFile);
    }
} // close_log

void make_prompt()
{
    if (aux_prompt) {
	MY_PRINTF(color.none, "%s", aux_prompt);
	fflush(stdout);
    } else {
	MY_PRINTF(color.none, "\n%s - %s> ", NAME, returnMyStatus());
	fflush(stdout);
    }
}

int cmd_clear(char *input)
{
    printf("[2J\n");
    MY_PRINTF(color.titleB, "\n%s %s\n", LONGNAME, VERSION);
    MY_PRINTF(color.titleD, "-------------------------------------------------------------------------------\n");
    return 0;
}

void mainLoop()
{
    /*
    struct timeval tv;
    fd_set fd1, fd2;

    FD_ZERO(&fd2);
    */
    int     stat;
    short   chan;
    $DESCRIPTOR (DEVICE,"TT:");
    int AST_PROC();
/*standrad tjafs*/
    time_t login_time;
    time_t login_begin;

    itm[1].length = 0;
    itm[1].type   = TRM$_MODIFIERS;
    itm[1].buffer = TRM$M_TM_NOFILTR | TRM$M_TM_ESCAPE | TRM$M_TM_NORECALL;
    itm[1].ret    = 0;
 
    itm[2].length = 0;
    itm[2].type   = TRM$_ESCTRMOVR;
    itm[2].buffer = 10;
    itm[2].ret    = 0;

    stat = sys$assign(&DEVICE,&chan,0,0);
    if ((stat&1)!=1) lib$stop(stat);

    FD_SET(0, &fd1);                             
    login_time = login_begin = time(NULL);      
    while (!done)
    {
        tv.tv_sec = MIN(0, tv.tv_sec);
        tv.tv_usec = MIN(250, tv.tv_usec);
        icq_main();

        if(logged_in == 0)
        {
            if (login_time < time(NULL))
            {
                login_time = time(NULL);
                MY_PRINTF(color.none, ".");
                fflush(stdout);
            }

            if (login_begin + 20 < time(NULL))
            {
                MY_PRINTF(color.none, " Could not login!\n");
		MY_PRINTF(color.none, "Logging in, try %d", ++loginTry);
		login_time = login_begin = time(NULL);
                
                send_logout();
                send_login();
                //done = 1;
            }
        }

        //tv.tv_sec = 0;
        //tv.tv_usec = 250;
        //fd1 = fd2;
        //select(1, &fd1, NULL, NULL, &tv);
//        if(FD_ISSET(0, &fd1))  
	if(logged_in && io==0)
        {
	    char prompt[100];
            int len;

            len=sprintf(prompt,"\n%s - %s> ", NAME, returnMyStatus());
            itm[0].length = len;
            itm[0].type   = TRM$_PROMPT;
            itm[0].buffer = (int)prompt;
            itm[0].ret    = 0;

	    if(DEBUG) printf("Har s{nt qio\n");

            stat = sys$qio(0,chan,(IO$_READVBLK|IO$M_EXTEND),&iosb,AST_PROC,
                           0,input,BUFSIZE,0,0,itm,36);
	    io=1;

/*            if (logged_in)
		done = !cmd_parse(input);*/
        }

        if (logged_in == -1)// We got kicked, relogin
        {
            logged_in = 0;
            send_login();
            loginTry = 1;
            MY_PRINTF(color.none, "Logging in, try %d", loginTry);
            login_time = login_begin = time(NULL);
        }
    }

}

AST_PROC()
{
    input[iosb.offset]= 0;

    io=0;
    if (logged_in) done = !cmd_parse(input);
}

void MY_PRINTF(char *color_,char *fmt,...)
{
	va_list format;
	va_start(format,fmt);
//	printf("%s", color_);
        vprintf(fmt,format);
//        printf("%s", color.none);
	va_end(format);
}

void MY_LOGF(char *color_, char *from_user, char *fmt,...)
{
	va_list format;
	char tmp_str[1024];

	va_start(format,fmt);
        vsprintf(tmp_str, fmt, format);
        icq_log(from_user, tmp_str);
	va_end(format);
}
 
 
void MY_LAPRINTF(char *color_, char *from_user, char *fmt,...)
{
	va_list format;
	char tmp_str[1024];

	va_start(format,fmt);
      	vsprintf(tmp_str, fmt, format);
//        printf("%s", color_);
        printf("%s", tmp_str);
        icq_log(from_user, tmp_str);
//        printf("%s", color.none);
	va_end(format);
}
